pro be_test1

;Setting the working directory and the input and output files
dir='/home/linux/data/Spectro-Interferometry/data/'
inputfile=dir+'param_example_simple.dat'
outputfile=dir+'datacube.fits'


;Computing the disk model
Be_disk_model,inputfile,outputfile=outputfile,outputarray=map,lam=lam,kinemap=kinemap,lineprofile=lineprofile


;Defining the set of baselines for the observation simulator
B=[50,50,50]
angle=[0,45,90]

;Runing the observations simulator
simulate_obs,outputfile,B=B,angle=angle,visi=visi,phase=phase,lam=lam


;Formating the plotting window 
!x.charsize=2
!y.charsize=2
!P.multi=[0,4,2]
window,0,xsize=1600,ysize=600


;Plotting the visibility for the three baselines
plot,lam*1e6,visi[0,*],yrange=[0,1]
plot,lam*1e6,visi[1,*],yrange=[0,1]
plot,lam*1e6,visi[2,*],yrange=[0,1]

!P.multi[0]=4

;Plotting the phases for the three baselines
plot,lam*1e6,phase[0,*]*!radeg,yrange=[-50,50]
plot,lam*1e6,phase[1,*]*!radeg,yrange=[-50,50]
plot,lam*1e6,phase[2,*]*!radeg,yrange=[-50,50]


!P.multi=[1,4,1]
;Plotting the line profile
plot,lam*1e6,lineprofile

!P.multi=0
end