pro be_test2

dir='/home/linux/data/Spectro-Interferometry/data/'
datadir=dir+'/amber/'

;Loading the amber data from the files in the amber
amber_getall_night,datadir,data=data,nobs=nobs,/deg


; The AMBER spectrum is not in the AMBER OIFits file and has to be extracted from another file.
spectra=readarray(datadir+'\alpha_col_final_spectrum.spec')  

; the xrange here for the plot is in microns. That's why lam is multiply by 1e6 in the calls to plot procedure
xr=[2.16,2.172] 



 ;7 subwindows per row = 3 for the visibilities + 3 for the differential phases + 1 for the closure phase + 1 for the profile
!P.multi=[0,8,nobs] 
window,0,xsize=1800,ysize=600


;Main plotting loops on i=observations  and j=baselines withing each observation
for i=0,nobs-1 do begin
  for j=0,2 do begin
    ;Visbility plot
    plot,*(data[i]).lam*1e6,sqrt((*(data[i].sqV))[*,j]),xrange=xr,yrange=[0,1.2] 
    ;Printing baselin length and orientation on the plot
    xyouts,2.166,0.1,"B!D"+strtrim(string(3*i+j+1),2)+"!N="+strtrim(string((*(data[i].B))[j],format='(F5.1)'),2)+"m    P.A.="+strtrim(string((*(data[i].angle))[j],format='(F6.1)'),2)+"!Uo!N",alignment=0.5
    ;Differential phase plot
    plot,*(data[i]).lam*1e6,((*(data[i].phi))[*,j]),xrange=xr,yrange=[-50,50]
   
  end
  ;Closure phase plot
  plot,*(data[i]).lam*1e6,(*(data[i].cphi)),xrange=xr,yrange=[-50,50]
  ;Spectra plot
  plot,spectra[0,*]*1e6,spectra[1,*],xrange=xr
  
end

!P.multi=0
end