pro be_test3


dir='/home/linux/data/Spectro-Interferometry/data/'
datadir=dir+'/amber/'
inputfile=dir+'param_example.dat'
outputfile=dir+'datacube.fits'


;Loading the amber data from the files in the amber directory
amber_getall_night,datadir,data=data,nobs=nobs,/deg
spectra=readarray(datadir+'/alpha_col_final_spectrum.spec')

;Computing the data-cube
Be_disk_model,inputfile,outputfile=outputfile,outputarray=map,lam=lam,kinemap=kinemap,lineprofile=lineprofile


;Extracting Baseline length and orientation from the data structure and puting them into 1D-arrays
B=[*(data[0].B),*(data[1].B)]
angle=[*(data[0].angle),*(data[1].angle)]

;Simulating observations using the computed datacube and the extracted baselines
simulate_obs,outputfile,B=B,angle=angle,visi=visi,phase=phase,lam=lam


;The xrange here is in micron that why lam is multiply by 1e6 in the calls to plot procedure
xr=[2.16,2.172]


;7 subwindows per row = 3 for the visibilities + 3 for the differential phases + 1 for the closure phase
!P.multi=[0,8,nobs]  
window,0,xsize=1800,ysize=600

;Main loops on i=observation and j=baseline
for i=0,nobs-1 do begin
  for j=0,2 do begin
    ;Plotting the observed visibility
    plot,*(data[i]).lam*1e6,sqrt((*(data[i].sqV))[*,j]),xrange=xr,yrange=[0,1.2]
    ;Overplotting the model visibility
    oplot,lam*1e6,visi[3*i+j,*],color=230 
    ;Printing baseline length and orientation       
    xyouts,2.166,0.1,"B!D"+strtrim(string(3*i+j+1),2)+"!N="+strtrim(string((*(data[i].B))[j],format='(F5.1)'),2)+"m    P.A.="+strtrim(string((*(data[i].angle))[j],format='(F6.1)'),2)+"!Uo!N",alignment=0.5
    ;Plotting the observed differential phase
    plot,*(data[i]).lam*1e6,((*(data[i].phi))[*,j]),xrange=xr,yrange=[-50,50]
    ;Overplotting the model differential phase
    oplot,lam*1e6,phase[3*i+j,*]*!radeg,color=230
  end
  ;Plotting the observed closure phase
  plot,*(data[i]).lam*1e6,(*(data[i].cphi)),xrange=xr,yrange=[-50,50]
  ;Overplotting the model closure phase= linear combination of the three differential phases
  oplot,lam*1e6,(phase[3*i+0,*]+phase[3*i+1,*]-phase[3*i+2,*])*!radeg,color=230 
  
 ;Plotting the observed spectrum
 plot,spectra[0,*]*1e6,spectra[1,*],xrange=xr
 ;Overplotting the model spectrum
 oplot,lam*1e6,lineprofile,color=230 
     
end

!P.multi=0
end