pro Be_disk_model,paramfile,outputArray=outputArray,lam=lam,pix=pix,outputFile=outputfile,quiet=quiet,kinemap=kinemap,lineprofile=lineprofile

pi=3.14159
deg=pi/180.
arcsec=deg/3600.
mas=arcsec/1000.
c=3e5 ;km/s
Ro=7e8 ;m
AU=1.49598e11 ;m

startTime=systime(1)

if not(keyword_set(quiet)) then quiet=0
if not(keyword_set(quiet)) then print,'reading parameters files : ',+paramfile

readparamfile,paramfile,dim=dim,taille=taille,nlam=nlam,lam0=lam0,dlam=dlam,res=res,incl=incl,distance=distance,Rstar=Rstar,$
					EnvDiamC=EnvDiamC,EnvPA=EnvPA,EnvFC=EnvFC,LineEqWidth=LineEqWidth,EnvDiamL=EnvDiamL,Vrot=Vrot,beta=beta ,v0=v0,vinf=vinf,gamma=gamma,quiet=quiet

map=fltarr(dim,dim,nlam)
;************************building the continuum map*******************************

x=(findgen(dim)/(dim-1)-0.5)*2*taille
mapStar=ellipse2(x=x,y=x,r=1.)
mapStar=float(mapStar)
ts=total(mapStar)
if (ts ne 0) then mapStar=mapStar/ts
if (ts eq 0) then mapStar(dim/2-1:dim/2,dim/2-1:dim/2)=0.25

;EnvTypeC=strtrim(EnvTypeC,2)
EnvTypeC='gauss'
case EnvTypeC of


	'gauss' : $
	begin
		r0=10
		d0=10
		theta=180/!RADEG
		x0=d0*sin(theta)
		y0=d0*cos(theta)
		Fo=0.0
		mapEnvC=egauss(x=x,y=x,fwhm=2*EnvDiamC,ori=EnvPA,apl=1./cos(incl*deg));*(1-Fo*ellipse(x=x+x0,y=x+y0,r=r0,ori=EnvPA,apl=1))
		mapEnvC=mapEnvC/total(mapEnvC)
	end

	'uniform' : $
	begin
		mapEnvC=ellipse2(x=x,y=x,r=EnvDiamC,ori=EnvPA,apl=1./cos(incl*deg))
		mapEnvC=mapEnvC/total(mapEnvC)

	end

	'map' : $
	begin
		mapEnvC=readfits(EnvMapFileC)
		mapEnvC=congrid(mapEnvC,dim,dim)
		mapEnvC=mapEnvC/total(mapEnvC)
	end

end

mapC=EnvFC*mapEnvC+(1-EnvFC)*mapStar

;************************building envelope map for the whole line***************************************



;EnvTypeL=strtrim(EnvTypeL,2)
EnvTypeL='gauss'
case EnvTypeL of


	'pow' : $
	begin
		pow=0.1
		if (n_elements(EnvDiamL) eq 2) then pow=EnvDiamL(1)
		EnvDiamL=EnvDiamL(0)
		mapEnvL=egauss(x=x,y=x,fwhm=2*EnvDiamL,ori=EnvPA,apl=1./cos(incl*deg))^pow
		mapEnvL=mapEnvL/total(mapEnvL)
	end



	'gauss' : $
	begin
		pow=1.
		if (n_elements(EnvDiamL) eq 2) then pow=EnvDiamL(1)
		EnvDiamL=EnvDiamL(0)
		mapEnvL=egauss(x=x,y=x,fwhm=2*EnvDiamL,ori=EnvPA,apl=1./cos(incl*deg))^pow;+0.1*egauss(x=x+x0,y=x+y0,fwhm=r0);*(1-Fo*ellipse(x=x+x0,y=x+y0,r=r0,ori=EnvPA,apl=1))
		mapEnvL=mapEnvL/total(mapEnvL)

	end

	'uniform' : $
	begin
		mapEnvL=ellipse2(x=x,y=x,r=EnvDiamL,ori=EnvPA,apl=1./cos(incl*deg))
		mapEnvL=mapEnvL/total(mapEnvL)



	end

	'map' : $
	begin
		;print,EnvMapFileL
		mapEnvL=readfits(EnvMapFileL)
		;help,mapEnvL
		dimMap=sqrt(n_elements(map))
		if (dimMap ne dim) then mapEnvL=congrid(mapEnvL,dim,dim)
		mapEnvL=mapEnvL/total(mapEnvL)
	end
end

mapEnvL(where(mapStar ne 0))=0

;starprofile=strtrim(starprofile,2)
starprofile='none'
if (starprofile ne 'none' and starprofile ne 'lineonly') then begin
	close,74
	line=''
	openr,74,starprofile
	readf,74,line
	temp=strsplit(line,' ',/extract)
	lamprofil=float(temp(0))
	profil=float(temp(1))
	while not(eof(74)) do begin
		readf,74,line
		temp=strsplit(line,' ',/extract)
		lamprofil=[lamprofil,float(temp(0))]
		profil=[profil,float(temp(1))]
	end
	close,74

end



lim=1;ellipse(x=x,y=x,r=10,ori=EnvPA,apl=1./cos(incl*deg)) ne 0




;************************building iso-velocity maps***************************************

kinemap=rot(disk_rot_2D(dim=dim,taille=taille,incl=incl,beta=beta,vrad=vrad,vrot=vrot,vinf=vinf,v0=v0,gamma=gamma),-EnvPA+90., /INTERP)

;print,total(mapEnvL)
mapL=fltarr(dim,dim,nlam)


dscat=1;
fscat=0;
dv=dlam*c/lam0
resv=res*c/lam0
dscatv=dscat*c/lam0
lam=(findgen(nlam)-(nlam-1)/2.)*dlam+lam0
if not(keyword_set(quiet)) then print,'dv = ',dv,'km/s'
if not(keyword_set(quiet)) then print,'resolution = ',resv,'km/s'
C1=mapEnvL*LineEqWidth;/dlam
C2=sqrt(2*pi)/2.3548*res;/dlam
C3=sqrt(2*pi)/2.3548*dscat;/dlam
C4=pi*dscat
;print,Fscat,dscatv
for i=0,nlam-1 do begin
	;print,'********************',i,'************************'
	v=(-nlam/2+i)*dv
	;print,v,dv,nlam
	;print,kinemap(dim/2,dim/2)
	;mapL(*,*,i)=(abs(kinemap-v) lt dv/2.)*C1
	mapL(*,*,i)=(1-Fscat)*exp(-(kinemap-v)^2./(2*(resv/2.3548)^2.))*C1/C2  + Fscat*exp(-(kinemap-v)^2./(2*(dscatv/2.3548)^2.))*C1/C3
	;mapL(*,*,i)=(1-Fscat)*exp(-(kinemap-v)^2./(2*(resv/2.3548)^2.))*C1/C2  + Fscat*1./(1.+(kinemap-v)^2./dscatv^2.)*C1/C4

	;mapL(*,*,i)=exp(-(kinemap-v)^2./(2*(resv/2.3548)^2.))*C1/C2
	;mapL(*,*,i)=mapL(*,*,i)*(1-Fscat) + Fscat*mapL(*,*,i)*exp(-(kinemap-v)^2./(2*(dscatv/2.3548)^2.))/C3


	;scat=exp(-(kinemap-v)^2./(2*(dscat/2.3548)^2.))*C1/C3
	if (starprofile eq 'none') then mapL(*,*,i)=(mapL(*,*,i)+mapC)*lim
	if (starprofile ne 'none' and starprofile ne 'lineonly') then mapL(*,*,i)=(mapL(*,*,i)+ EnvFC*mapEnvC+(1-EnvFC)*mapStar*interpol(profil,lamprofil,lam(i)))*lim
	if (starprofile eq 'lineonly') then MapL(*,*,i)=mapL(*,*,i)*lim


end

	;print,total(mapL)
	;print,LineEqWidth

;************************creating outputs**********************************************
outputArray=mapL
pix=1.*taille/dim*2*Rstar*Ro/AU/distance*1000 ; en mas
if not(keyword_set(quiet))then begin
	print,taille,dim,Rstar,Ro,AU,distance
	print,pix
	print,mas
end


pix=pix*mas
;************************creating fits datacube******************************************

if keyword_set(outputfile) then begin

	writefits,outputfile,outputArray
	a=readfits(outputfile,h,silent=quiet)
	sxaddpar,h,'CDELT1',pix
	sxaddpar,h,'CDELT2',pix
	sxaddpar,h,'CDELT3',dlam*1e-10
	sxaddpar,h,'CRPIX1',dim/2
	sxaddpar,h,'CRPIX2',dim/2
	sxaddpar,h,'CRPIX3',nlam/2
	sxaddpar,h,'CRVAL1',0
	sxaddpar,h,'CRVAL2',0
	sxaddpar,h,'CRVAL3',lam0*1e-10
	if not(keyword_set(quiet)) then print,h
	writefits,outputfile,outputArray,h

end
;*************************Computing line profile*****************************************************
lineprofile=total(total(outputArray,1),1)

;*************************finishing*****************************************************
if not(keyword_set(quiet)) then print,'computation time : ',systime(1)-startTime,'seconds'
end