function disk_rot_2D,dim=dim,taille=taille,incl=incl,rin=rin,beta=beta,vrad=vrad,vrot=vrot,vinf=vinf,v0=v0,gamma=gamma

pi=3.14159265
deg=pi/180.
incl1=incl*deg

if not(keyword_set(beta)) then beta=-0.5
if not(keyword_set(alpha)) then alpha=-2.
if not(keyword_set(rin)) then rin=1


x=((findgen(dim,dim) mod dim) /(dim-1)-0.5)*2*taille
y=transpose(x)/cos(incl1)




r=sqrt(x^2.+y^2.)
phi=atan(x,y)


vphi=vrot*r^(beta)
req0=where( r eq 0)
isreq0=total(req0)
if (isreq0 ne -1) then vphi(req0)=0
if keyword_set(vrad) then vr=vrad
if keyword_set(vinf) then begin
	if not(keyword_set(gamma)) then gamma=0.86
	if  not(keyword_set(v0)) then v0=0.

	vr=v0+(Vinf-v0)*(1.-1./r)^(1.*gamma)
end
if not(keyword_set(vrad) or keyword_set(vinf)) then vr=0.

vproj=fltarr(dim,dim)
vproj=(vphi*sin(phi)-vr*cos(phi))*sin(incl1)


return,vproj

end

function disk_rot_2D_old,dim=dim,taille=taille,incl=incl,rin=rin,rout=rout,alpha=alpha,beta=beta,vrad=vrad,vrot=vrot,vinf=vinf,v0=v0,gamma=gamma

pi=3.14159265
deg=pi/180.
incl=incl*deg

if not(keyword_set(beta)) then beta=-0.5
if not(keyword_set(alpha)) then alpha=-2.
if not(keyword_set(rout)) then rout=taille
if not(keyword_set(rin)) then rin=0


x=((findgen(dim,dim) mod dim) /dim-0.5)*taille
y=transpose(x)

r=sqrt(x^2.+y^2.)
phi=atan(x,y)

map=r^(alpha)*((r ge rin) and (r le rout))

dim2=round(1.*dim*cos(incl)/2)*2

map2=fltarr(dim,dim)
map2(*,dim/2-dim2/2:dim/2+dim2/2-1)=congrid(map,dim,dim2)

vphi=vrot*r^(beta)

if keyword_set(vrad) then vr=vrad
if keyword_set(vinf) then begin
	if not(keyword_set(gamma)) then gamma=0.86
	if  not(keyword_set(v0)) then v0=0.

	vr=v0+(Vinf-v0)*(1.-1./r)^(1.*gamma)
end
if not(keyword_set(vrad) or keyword_set(vinf)) then vr=0.

vproj=fltarr(dim,dim)
vproj=(vphi*sin(phi)-vr*cos(phi))*cos(incl)

vproj2=fltarr(dim,dim)
vproj2(*,dim/2-dim2/2:dim/2+dim2/2-1)=congrid(vproj,dim,dim2)

return,{map:map2,vproj:vproj2}
end