pro simulate_obs,Fitsfile,spafreq=spafreq,B=B,angle=angle,OiFitsIn=OiFitsIn,OiFitsOut=OiFitsOut,visi=visi,phase=phase,temp=temp,lam=lam,precision=precision,quiet=quiet

start=systime(1)


if not(keyword_set(precision)) then precision=2
if not(keyword_set(spafreq)) and keyword_set(B) and keyword_set(angle) then begin
	Bx=-B*sin(angle/!RADEG)
	By=B*cos(angle/!RADEG)
	if not(keyword_set(quiet)) then  print,Bx,By
end


	if not(keyword_set(quiet)) then map=readfits(Fitsfile,h)
		if keyword_set(quiet) then map=readfits(Fitsfile,h,/silent)

for i=0,n_elements(h)-2 do begin
	temp=strtrim(strsplit(h(i),'/',/extract),2)
	temp=strtrim(strsplit(temp(0),'=',/extract),2)

	if n_elements(temp) eq 2 then begin
		if temp(1) ne 'T' then begin
			command=temp(0)+'='+temp(1)
			if not(keyword_set(quiet)) then print,command
			a=execute(command)
		end
	end
end
if not(keyword_set(quiet)) then  print, NAXIS1,NAXIS2,NAXIS3

if not(keyword_set(NAXIS3)) then NAXIS3=1


;pix1=1./(float(NAXIS1)*CDELT1)
;pix2=1./(float(NAXIS2)*CDELT2)

pix1=1./(float(NAXIS1)*CDELT1*precision)
pix2=1./(float(NAXIS2)*CDELT2*precision)


;scale1=(findgen(NAXIS1)-CRPIX1)*pix1/precision
;scale2=(findgen(NAXIS2)-CRPIX2)*pix2/precision

scale1=(findgen(NAXIS1*precision)-CRPIX1*precision)*pix1
scale2=(findgen(NAXIS2*precision)-CRPIX2*precision)*pix2


visi=fltarr(n_elements(Bx),NAXIS3)
phase=fltarr(n_elements(Bx),NAXIS3)

lam=(CRVAL3+(findgen(NAXIS3)-CRPIX3)*CDELT3)

nB=n_elements(Bx)

x0=fltarr(nB,NAXIS3)
y0=fltarr(nB,NAXIS3)

;for i=0,nB-1 do x0(i,*)=interpol(findgen(NAXIS1),scale1,Bx(i)/lam)
;for i=0,nB-1 do y0(i,*)=interpol(findgen(NAXIS2),scale2,By(i)/lam)

for i=0,nB-1 do x0(i,*)=interpol(findgen(NAXIS1*precision),scale1,Bx(i)/lam)
for i=0,nB-1 do y0(i,*)=interpol(findgen(NAXIS2*precision),scale2,By(i)/lam)

vcompl=complexarr(n_elements(Bx),NAXIS3)

for i=0,NAXIS3-1 do begin
	mapi=map(*,*,i)
	if keyword_set(precision) then begin
		map2=fltarr(precision*NAXIS1,precision*NAXIS2)
		map2(NAXIS1/2*(precision-1):NAXIS1/2*(precision+1)-1,NAXIS2/2*(precision-1):NAXIS2/2*(precision+1)-1)=mapi
		mapi=map2
	end
	;print,'***********************',i,'**********************'
	;vcomplmap=shift(fft(shift(mapi,precision*NAXIS1/2,precision*NAXIS2/2)),precision*NAXIS1/2,precision*NAXIS2/2)
	vcomplmap=shift(fft(shift(mapi,CRPIX1*precision,CRPIX2*precision)),CRPIX1*precision,CRPIX2*precision)

	visimap=abs(vcomplmap)
	norm=max(visimap)


	visi(*,i)=abs(vcompl(*,i))
	phase(*,i)=atan(vcompl(*,i),/phase)

	visimap=visimap/norm
	;visi(*,i)=visimap(x0(*,i),y0(*,i))
	visi(*,i)=(bilinear(visimap,x0(*,i),y0(*,i))*identity(nB))#(fltarr(nB)+1)

	phasemap=atan(vcomplmap/norm,/phase)
	;phase(*,i)=phasemap(x0(*,i),y0(*,i))
	phase(*,i)=(bilinear(phasemap,x0(*,i),y0(*,i))*identity(nB))#(fltarr(nB)+1)

end


for i=0,nB-1 do begin
phasemoy=total(phase(i,*))/n_elements(phase(i,*))
;print,phasemoy,abs(phasemoy-!DPI),abs(phasemoy+!DPI),abs(phasemoy)
;if (abs(phasemoy-!DPI/2)lt abs(phasemoy)) or (abs(phasemoy+!DPI/2)lt abs(phasemoy)) then  phase(i,*)=atan(-1*exp(complex(0,1)*(phase(i,*))))
phase(i,*)=atan(exp(complex(0,1)*phase(i,*))*exp(complex(0,-1)*phasemoy),/phase)
end

for i=0,nB-1 do phase(i,*)=phase(i,*)-phase(i,0)
wm=where(phase lt -!DPI)
if (wm(0) ne -1) then phase(wm)=phase(wm)+2*!DPI
wp=where(phase gt !DPI)
if (wp(0) ne -1) then phase(wp)=phase(wp)-2*!DPI

;temp=tf
if not(keyword_set(quiet)) then print,systime(1)-start,'secondes'
end