function egauss,sigma=sigma,FWHM=FWHM,x=x,y=y,apl=apl,ori=ori,simple=simple

if not(KEYWORD_SET(ori)) then ori=0
if not(KEYWORD_SET(apl)) then apl=1.

pi=3.14159
ori_rad=-ori*pi/180.+pi/2
if not((keyword_set(sigma)) or (keyword_set(FWHM))) then sigma=1
if keyword_set(FWHM) then sigma=FWHM/2.3548


if keyword_set(simple) then begin
	nx=n_elements(x)
	ny=n_elements(y)
	if (nx eq ny) then begin
		g=fltarr(nx)
		xp=x*cos(ori_rad)-y*sin(ori_rad)
		yp=x*sin(ori_rad)+y*cos(ori_rad)
		g=exp(-(xp^2.+yp^2.*apl^2.)/(2*sigma^2.))
		return,g
	end

end

if not(keyword_set(simple)) then begin
	id=fltarr(n_elements(x))+1

	xx=x#transpose(id)
	yy=id#transpose(y)


	xp=xx*cos(ori_rad)-yy*sin(ori_rad)
	yp=xx*sin(ori_rad)+yy*cos(ori_rad)

	g=exp(-(xp^2.+yp^2.*apl^2.)/(2*sigma^2.))

	return,g
end




end







function new_egauss,sigma=sigma,FWHM=FWHM,x=x,y=y,apl=apl,ori=ori,simple=simple

pi=3.14159
ori_rad=-ori*pi/180.+pi/2
if not((keyword_set(sigma)) or (keyword_set(FWHM))) then sigma=1
if keyword_set(FWHM) then sigma=FWHM/2.3548


nx=n_elements(x)
ny=n_elements(y)


if not(keyword_set(simple)) then begin
g=fltarr(nx,ny)
for i=0,nx-1  do begin
	for j=0,ny-1 do begin
		xp=x(i)*cos(ori_rad)-y(j)*sin(ori_rad)
		yp=x(i)*sin(ori_rad)+y(j)*cos(ori_rad)
		g(i,j)=exp(-(xp^2.+yp^2.*apl^2.)/(2*sigma^2.))
	end
end
return,g
end


if (keyword_set(simple) and (nx eq ny)) then begin
g=fltarr(nx)
for i=0,nx-1  do begin
		xp=x(i)*cos(ori_rad)-y(i)*sin(ori_rad)
		yp=x(i)*sin(ori_rad)+y(i)*cos(ori_rad)
		g(i)=exp(-(xp^2.+yp^2.*apl^2.)/(2*sigma^2.))

end
return,g
end


end
